/*
 * RaceTrap.java
 *
 * Created on 22. juni 2000, 13:48
 * 
 * Brian Vinter
 */

import java.io.*;
import java.awt.*;

class cRouteDefinition {                    //This class describes a route through the route
    double dLength;                         //The length of the route found in baPath
    byte iSet;                               //How many have been laied?
    byte [] baPath;	                        //The Laied path and the points that remains
    
    cRouteDefinition(){dLength=0; iSet=0;}//Constructor for a new instance that gets path and rest elsewhere
    
    cRouteDefinition(int iSize){            //Constructor for an instance that also generates space for path and rest
	  dLength=0; iSet=0; 
	  baPath=new byte[iSize];
    }
}


public class RaceTrap {                    //The trap
  static int iSize;                      //Number of grain-bags
  static int [][] iaaCoors;              //Coordinates for the grain-bags
  static double [][] daaDistanceTable;   //Full table for distance between any two grain-bags
  final static double dMinRouteLen=10E100;//Large number used for initial best distance
  static graphicsScreen oScreen;         //The display object
  static double dGlobalBest=dMinRouteLen;//Bounding variable

  static void zPlotRoute(byte [] baOrder){ //This function simply plots a route to the display
    oScreen.clear();      	
    for(int i=0; i<iSize; i++)
      oScreen.dot(iaaCoors[i][0], iaaCoors[i][1], 10, Color.red); 
	  for(int i=0; i<iSize-1; i++)
        oScreen.line(iaaCoors[baOrder[i]][0], iaaCoors[baOrder[i]][1], iaaCoors[baOrder[i+1]][0], iaaCoors[baOrder[i+1]][1], Color.red);    
	  oScreen.line(iaaCoors[baOrder[iSize-1]][0], iaaCoors[baOrder[iSize-1]][1], iaaCoors[baOrder[0]][0], iaaCoors[baOrder[0]][1], Color.red);    
  }
    
  static cRouteDefinition zRoute(cRouteDefinition oRoute){ //This is our recursive route finder
    cRouteDefinition oBest=new cRouteDefinition();         //The subtree that will eventually be returned
    oBest.dLength=dMinRouteLen;
	
    if(oRoute.iSet==iSize){ //If all grain-bags have been placed we simply add the distance to get beck home
      oRoute.dLength+=daaDistanceTable[oRoute.baPath[oRoute.iSet-1]][oRoute.baPath[0]];
      return oRoute;
    }
	
    byte c=oRoute.baPath[oRoute.iSet];
    for(int i=oRoute.iSet;i<iSize;i++){
      double dNewLength=oRoute.dLength+daaDistanceTable[oRoute.baPath[oRoute.iSet-1]][oRoute.baPath[i]];
      //If the partial route is smaller that the best known route we probe deeber into the tree
	  if(dNewLength<dGlobalBest){
        cRouteDefinition oPermutation=new cRouteDefinition(); //A new instance of route where we create a new permutation
	    oPermutation.baPath=(byte [])oRoute.baPath.clone();   //Inherit the path
		oPermutation.baPath[oRoute.iSet]=oRoute.baPath[i];
		oPermutation.baPath[i]=c;
	    oPermutation.iSet=oRoute.iSet;
	    oPermutation.iSet++;   //One more bag is placed!
		//Add the new bag to the total distance for the path
	    oPermutation.dLength=dNewLength;
		cRouteDefinition oResult = zRoute(oPermutation);
		if(oResult.dLength<oBest.dLength){ //Best route so far?
		  oBest=oResult;
		  if(oBest.dLength<dGlobalBest){
		    dGlobalBest=oBest.dLength;
		    zPlotRoute(oBest.baPath);
		  }
	    }
	  }
    }
	return oBest;
  }
    
  static double zEuclidDist(int [] from, int [] to){ //In the dessert the shortest route is a straight line:)
    double dx=Math.abs(from[0]-to[0]);
    double dy=Math.abs(from[1]-to[1]);
    return(Math.sqrt(dx*dx+dy*dy));
  }
    
  static void zReadRoute(){ //Reads coordinates from a file and generates a distance-table - ugly as hell!! :)
      
    BufferedReader oDataStream;
    try {
      oDataStream = new BufferedReader(new InputStreamReader(new FileInputStream("route.dat")));
    }
    catch (FileNotFoundException e) {
      System.out.println("Reading file aborted"+e);
      return;
    }
	
    iSize=0;

    try {
      iSize=new Integer(oDataStream.readLine()).intValue();
    } catch(IOException e) {};

    daaDistanceTable=new double[iSize][iSize];
    iaaCoors=new int[iSize][2];
  
    String sIn="";
	  
    for(int i=0;i<iSize;i++){
      try {
        sIn=oDataStream.readLine();
      } catch(IOException e) {};
	      
      int k=0;
      char [] caInChars=sIn.toCharArray();
      for(int j=0;j<2;j++){
        int l=0;
        char [] caEntry = new char[255];
        while((caInChars[k]!=' ') && (caInChars[k]!='\0'))caEntry[l++]=caInChars[k++];
	    k++;
	    iaaCoors[i][j]=(new Integer(new String(caEntry,0,l))).intValue();
      }
    }
	  
    for(int i=0; i<iSize; i++)	  
	  for(int j=0; j<iSize; j++)	  
	    daaDistanceTable[i][j]=zEuclidDist(iaaCoors[i],iaaCoors[j]);
  }
    
    
  public static void main (String args[]) {

    StopWatch oTimer=new StopWatch();

    zReadRoute();
    try {Thread.sleep((long)1000);}catch(Exception e){}//Handles a little race-condition in remote X and java :)
	oScreen=new graphicsScreen(501,501);
	
	cRouteDefinition oOriginalRoute=new cRouteDefinition(iSize); //Initial route - as read in the file
	for(int i=0; i<iSize; i++)
	  oOriginalRoute.baPath[i]=(byte)i;
	
	zPlotRoute(oOriginalRoute.baPath); //Show the original route
	
	oOriginalRoute.dLength=0.0;
	oOriginalRoute.iSet=1;
	
	oTimer.start();
	cRouteDefinition res=zRoute(oOriginalRoute);  //Find the best route:)
	oTimer.stop();
	zPlotRoute(res.baPath);           //Show the best route
	
    String sLife="alive";
	if(res.dLength/iSize>200)sLife="dead";
	
	System.out.println("Route length is "+res.dLength+" the roadrunner is "+sLife+" found in "+oTimer.timeString());
  }
}
